package de.saumya.mojo.gem;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on gem-maven-plugin.<br/> Call <pre>  mvn gem:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Sat May 15 18:13:51 IST 2010
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.5.1)
 * @goal help
 * @requiresProject false
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "de.saumya.mojo:gem-maven-plugin:0.12.0", 0 );
        append( sb, "", 0 );

        append( sb, "Gem Maven Mojo", 0 );
        append( sb, "aggregation project for various jruby related maven plugins", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 10 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "build".equals( goal ) )
        {
            append( sb, "gem:build", 0 );
            append( sb, "Deprecated. use package goal", 1 );
            if ( detail )
            {
                append( sb, "", 0 );
                append( sb, "goal to build a gem from the given project. must be of type \'gem\'. it takes the metainfo from the pom alongs with extra configuration of the plugin to build the gem.", 1 );
            }
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "dependencies", 2 );
                append( sb, "map of dependency where the key is the gemname and value is the version pattern", 3 );
                append( sb, "", 0 );

                append( sb, "developmentDependencies", 2 );
                append( sb, "map of developer dependency where the key is the gemname and value is the version pattern", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: true)", 2 );
                append( sb, "fork the JRuby execution.", 3 );
                append( sb, "", 0 );

                append( sb, "gemDirectory (Default: ${project.build.directory}/${project.artifactId})", 2 );
                append( sb, "temporary directory to collect all the files for the gem", 3 );
                append( sb, "", 0 );

                append( sb, "gemFile (Default: ${project.build.directory}/${project.build.finalName}-java.gem)", 2 );
                append( sb, "file of the final gem.", 3 );
                append( sb, "", 0 );

                append( sb, "gemfilesets", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "gemFlagsDirectory (Default: ${project.build.directory}/gems)", 2 );
                append( sb, "directory to leave some flags for already installed gems.", 3 );
                append( sb, "", 0 );

                append( sb, "gemHome (Default: ${project.build.directory}/rubygems)", 2 );
                append( sb, "directory of gem home to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "gemPath (Default: ${project.build.directory}/rubygems)", 2 );
                append( sb, "directory of JRuby path to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "gemSpec (Default: ${project.build.directory}/${project.artifactId}.gemspec)", 2 );
                append( sb, "the file location for the generated gemspec", 3 );
                append( sb, "", 0 );

                append( sb, "home (Default: ${jruby.home})", 2 );
                append( sb, "directory of JRuby home to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "jarfile (Default: ${project.build.directory}/${project.build.finalName}.jar)", 2 );
                append( sb, "file of the generated jar file", 3 );
                append( sb, "", 0 );

                append( sb, "launchDirectory", 2 );
                append( sb, "the launch directory for the JRuby execution.", 3 );
                append( sb, "", 0 );

                append( sb, "launchMemory (Default: 384m)", 2 );
                append( sb, "The amount of memory to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "outputFile", 2 );
                append( sb, "output file where the stdout will be redirected to", 3 );
                append( sb, "", 0 );

                append( sb, "project", 2 );
                append( sb, "reference to maven project for internal use.", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "verbose jruby related output", 3 );
                append( sb, "", 0 );

                append( sb, "version (Default: ${jruby.version})", 2 );
                append( sb, "if the pom.xml has no runtime dependency to a jruby-complete.jar then this version is used to resolve the jruby-complete dependency from the local/remote maven repository. defaults to \'1.4.1\'.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "gem".equals( goal ) )
        {
            append( sb, "gem:gem", 0 );
            append( sb, "goal to run gem with the given arguments.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "args (Default: ${gem.args})", 2 );
                append( sb, "arguments for the gem command of JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: true)", 2 );
                append( sb, "fork the JRuby execution.", 3 );
                append( sb, "", 0 );

                append( sb, "gemFlagsDirectory (Default: ${project.build.directory}/gems)", 2 );
                append( sb, "directory to leave some flags for already installed gems.", 3 );
                append( sb, "", 0 );

                append( sb, "gemHome (Default: ${project.build.directory}/rubygems)", 2 );
                append( sb, "directory of gem home to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "gemPath (Default: ${project.build.directory}/rubygems)", 2 );
                append( sb, "directory of JRuby path to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "home (Default: ${jruby.home})", 2 );
                append( sb, "directory of JRuby home to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "launchDirectory", 2 );
                append( sb, "the launch directory for the JRuby execution.", 3 );
                append( sb, "", 0 );

                append( sb, "launchMemory (Default: 384m)", 2 );
                append( sb, "The amount of memory to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "outputFile", 2 );
                append( sb, "output file where the stdout will be redirected to", 3 );
                append( sb, "", 0 );

                append( sb, "project", 2 );
                append( sb, "reference to maven project for internal use.", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "verbose jruby related output", 3 );
                append( sb, "", 0 );

                append( sb, "version (Default: ${jruby.version})", 2 );
                append( sb, "if the pom.xml has no runtime dependency to a jruby-complete.jar then this version is used to resolve the jruby-complete dependency from the local/remote maven repository. defaults to \'1.4.1\'.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "gemify".equals( goal ) )
        {
            append( sb, "gem:gemify", 0 );
            append( sb, "goal to convert that artifact into a gem.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "artifactId (Default: ${artifactId})", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "buildDirectory (Default: ${project.build.directory})", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: true)", 2 );
                append( sb, "fork the JRuby execution.", 3 );
                append( sb, "", 0 );

                append( sb, "gemFlagsDirectory (Default: ${project.build.directory}/gems)", 2 );
                append( sb, "directory to leave some flags for already installed gems.", 3 );
                append( sb, "", 0 );

                append( sb, "gemHome (Default: ${project.build.directory}/rubygems)", 2 );
                append( sb, "directory of gem home to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "gemify (Default: ${project.build.directory}/gemify)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "gemPath (Default: ${project.build.directory}/rubygems)", 2 );
                append( sb, "directory of JRuby path to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "groupId (Default: ${groupId})", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "home (Default: ${jruby.home})", 2 );
                append( sb, "directory of JRuby home to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "launchDirectory", 2 );
                append( sb, "the launch directory for the JRuby execution.", 3 );
                append( sb, "", 0 );

                append( sb, "launchMemory (Default: 384m)", 2 );
                append( sb, "The amount of memory to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "outputFile", 2 );
                append( sb, "output file where the stdout will be redirected to", 3 );
                append( sb, "", 0 );

                append( sb, "project", 2 );
                append( sb, "reference to maven project for internal use.", 3 );
                append( sb, "", 0 );

                append( sb, "skipGemInstall (Default: ${skipGemInstall})", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "verbose jruby related output", 3 );
                append( sb, "", 0 );

                append( sb, "version (Default: ${version})", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "gem:help", 0 );
            append( sb, "Display help information on gem-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0gem:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "initialize".equals( goal ) )
        {
            append( sb, "gem:initialize", 0 );
            append( sb, "(no description available)", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "forceVersion (Default: false)", 2 );
                append( sb, "allow to overwrite the version by explicitly declaring a dependency in the pom. will not check any dependencies on gemspecs level.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: true)", 2 );
                append( sb, "fork the JRuby execution.", 3 );
                append( sb, "", 0 );

                append( sb, "gemFlagsDirectory (Default: ${project.build.directory}/gems)", 2 );
                append( sb, "directory to leave some flags for already installed gems.", 3 );
                append( sb, "", 0 );

                append( sb, "gemHome (Default: ${project.build.directory}/rubygems)", 2 );
                append( sb, "directory of gem home to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "gemPath (Default: ${project.build.directory}/rubygems)", 2 );
                append( sb, "directory of JRuby path to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "home (Default: ${jruby.home})", 2 );
                append( sb, "directory of JRuby home to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "includeOpenSSL (Default: true)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "launchDirectory", 2 );
                append( sb, "the launch directory for the JRuby execution.", 3 );
                append( sb, "", 0 );

                append( sb, "launchMemory (Default: 384m)", 2 );
                append( sb, "The amount of memory to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "offline", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "outputFile", 2 );
                append( sb, "output file where the stdout will be redirected to", 3 );
                append( sb, "", 0 );

                append( sb, "pluginArtifacts (Default: ${plugin.artifacts})", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "project", 2 );
                append( sb, "reference to maven project for internal use.", 3 );
                append( sb, "", 0 );

                append( sb, "useTransitiveDependencies (Default: false)", 2 );
                append( sb, "follow transitive dependencies when initializing rubygem dependencies.", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "verbose jruby related output", 3 );
                append( sb, "", 0 );

                append( sb, "version (Default: ${jruby.version})", 2 );
                append( sb, "if the pom.xml has no runtime dependency to a jruby-complete.jar then this version is used to resolve the jruby-complete dependency from the local/remote maven repository. defaults to \'1.4.1\'.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "install".equals( goal ) )
        {
            append( sb, "gem:install", 0 );
            append( sb, "goal to locally install a given gem", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "args (Default: ${gem.install})", 2 );
                append( sb, "arguments for the gem command of JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "artifact", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: true)", 2 );
                append( sb, "fork the JRuby execution.", 3 );
                append( sb, "", 0 );

                append( sb, "gemFlagsDirectory (Default: ${project.build.directory}/gems)", 2 );
                append( sb, "directory to leave some flags for already installed gems.", 3 );
                append( sb, "", 0 );

                append( sb, "gemHome (Default: ${project.build.directory}/rubygems)", 2 );
                append( sb, "directory of gem home to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "gemPath (Default: ${project.build.directory}/rubygems)", 2 );
                append( sb, "directory of JRuby path to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "home (Default: ${jruby.home})", 2 );
                append( sb, "directory of JRuby home to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "launchDirectory", 2 );
                append( sb, "the launch directory for the JRuby execution.", 3 );
                append( sb, "", 0 );

                append( sb, "launchMemory (Default: 384m)", 2 );
                append( sb, "The amount of memory to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "outputFile", 2 );
                append( sb, "output file where the stdout will be redirected to", 3 );
                append( sb, "", 0 );

                append( sb, "project", 2 );
                append( sb, "reference to maven project for internal use.", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "verbose jruby related output", 3 );
                append( sb, "", 0 );

                append( sb, "version (Default: ${jruby.version})", 2 );
                append( sb, "if the pom.xml has no runtime dependency to a jruby-complete.jar then this version is used to resolve the jruby-complete dependency from the local/remote maven repository. defaults to \'1.4.1\'.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "install-gems".equals( goal ) )
        {
            append( sb, "gem:install-gems", 0 );
            append( sb, "Deprecated. use InstallMojo instead", 1 );
            if ( detail )
            {
                append( sb, "", 0 );
                append( sb, "goal to run gem install", 1 );
            }
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "fork (Default: true)", 2 );
                append( sb, "fork the JRuby execution.", 3 );
                append( sb, "", 0 );

                append( sb, "gemFlagsDirectory (Default: ${project.build.directory}/gems)", 2 );
                append( sb, "directory to leave some flags for already installed gems.", 3 );
                append( sb, "", 0 );

                append( sb, "gemHome (Default: ${project.build.directory}/rubygems)", 2 );
                append( sb, "directory of gem home to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "gemPath (Default: ${project.build.directory}/rubygems)", 2 );
                append( sb, "directory of JRuby path to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "gems (Default: ${jruby.gems})", 2 );
                append( sb, "list of comma separated gem names.", 3 );
                append( sb, "", 0 );

                append( sb, "home (Default: ${jruby.home})", 2 );
                append( sb, "directory of JRuby home to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "launchDirectory", 2 );
                append( sb, "the launch directory for the JRuby execution.", 3 );
                append( sb, "", 0 );

                append( sb, "launchMemory (Default: 384m)", 2 );
                append( sb, "The amount of memory to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "outputFile", 2 );
                append( sb, "output file where the stdout will be redirected to", 3 );
                append( sb, "", 0 );

                append( sb, "project", 2 );
                append( sb, "reference to maven project for internal use.", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "verbose jruby related output", 3 );
                append( sb, "", 0 );

                append( sb, "version (Default: ${jruby.version})", 2 );
                append( sb, "if the pom.xml has no runtime dependency to a jruby-complete.jar then this version is used to resolve the jruby-complete dependency from the local/remote maven repository. defaults to \'1.4.1\'.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "list".equals( goal ) )
        {
            append( sb, "gem:list", 0 );
            append( sb, "goal to run \'gem list\'.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "args (Default: ${gem.list})", 2 );
                append( sb, "arguments for the gem command of JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: true)", 2 );
                append( sb, "fork the JRuby execution.", 3 );
                append( sb, "", 0 );

                append( sb, "gemFlagsDirectory (Default: ${project.build.directory}/gems)", 2 );
                append( sb, "directory to leave some flags for already installed gems.", 3 );
                append( sb, "", 0 );

                append( sb, "gemHome (Default: ${project.build.directory}/rubygems)", 2 );
                append( sb, "directory of gem home to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "gemPath (Default: ${project.build.directory}/rubygems)", 2 );
                append( sb, "directory of JRuby path to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "home (Default: ${jruby.home})", 2 );
                append( sb, "directory of JRuby home to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "launchDirectory", 2 );
                append( sb, "the launch directory for the JRuby execution.", 3 );
                append( sb, "", 0 );

                append( sb, "launchMemory (Default: 384m)", 2 );
                append( sb, "The amount of memory to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "outputFile", 2 );
                append( sb, "output file where the stdout will be redirected to", 3 );
                append( sb, "", 0 );

                append( sb, "project", 2 );
                append( sb, "reference to maven project for internal use.", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "verbose jruby related output", 3 );
                append( sb, "", 0 );

                append( sb, "version (Default: ${jruby.version})", 2 );
                append( sb, "if the pom.xml has no runtime dependency to a jruby-complete.jar then this version is used to resolve the jruby-complete dependency from the local/remote maven repository. defaults to \'1.4.1\'.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "package".equals( goal ) )
        {
            append( sb, "gem:package", 0 );
            append( sb, "goal to convert that artifact into a gem.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "buildDirectory", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: true)", 2 );
                append( sb, "fork the JRuby execution.", 3 );
                append( sb, "", 0 );

                append( sb, "gemFlagsDirectory (Default: ${project.build.directory}/gems)", 2 );
                append( sb, "directory to leave some flags for already installed gems.", 3 );
                append( sb, "", 0 );

                append( sb, "gemHome (Default: ${project.build.directory}/rubygems)", 2 );
                append( sb, "directory of gem home to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "gemPath (Default: ${project.build.directory}/rubygems)", 2 );
                append( sb, "directory of JRuby path to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "gemSpec (Default: ${gemspec})", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "home (Default: ${jruby.home})", 2 );
                append( sb, "directory of JRuby home to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "launchDirectory", 2 );
                append( sb, "the launch directory for the JRuby execution.", 3 );
                append( sb, "", 0 );

                append( sb, "launchMemory (Default: 384m)", 2 );
                append( sb, "The amount of memory to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "outputFile", 2 );
                append( sb, "output file where the stdout will be redirected to", 3 );
                append( sb, "", 0 );

                append( sb, "project", 2 );
                append( sb, "reference to maven project for internal use.", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "verbose jruby related output", 3 );
                append( sb, "", 0 );

                append( sb, "version (Default: ${jruby.version})", 2 );
                append( sb, "if the pom.xml has no runtime dependency to a jruby-complete.jar then this version is used to resolve the jruby-complete dependency from the local/remote maven repository. defaults to \'1.4.1\'.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "spec".equals( goal ) )
        {
            append( sb, "gem:spec", 0 );
            append( sb, "goal to run \'gem spec\'.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "args (Default: ${gem.spec})", 2 );
                append( sb, "arguments for the gem command of JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "fork (Default: true)", 2 );
                append( sb, "fork the JRuby execution.", 3 );
                append( sb, "", 0 );

                append( sb, "gemFlagsDirectory (Default: ${project.build.directory}/gems)", 2 );
                append( sb, "directory to leave some flags for already installed gems.", 3 );
                append( sb, "", 0 );

                append( sb, "gemHome (Default: ${project.build.directory}/rubygems)", 2 );
                append( sb, "directory of gem home to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "gemPath (Default: ${project.build.directory}/rubygems)", 2 );
                append( sb, "directory of JRuby path to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "home (Default: ${jruby.home})", 2 );
                append( sb, "directory of JRuby home to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "launchDirectory", 2 );
                append( sb, "the launch directory for the JRuby execution.", 3 );
                append( sb, "", 0 );

                append( sb, "launchMemory (Default: 384m)", 2 );
                append( sb, "The amount of memory to use when forking JRuby.", 3 );
                append( sb, "", 0 );

                append( sb, "outputFile", 2 );
                append( sb, "output file where the stdout will be redirected to", 3 );
                append( sb, "", 0 );

                append( sb, "project", 2 );
                append( sb, "reference to maven project for internal use.", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "verbose jruby related output", 3 );
                append( sb, "", 0 );

                append( sb, "version (Default: ${jruby.version})", 2 );
                append( sb, "if the pom.xml has no runtime dependency to a jruby-complete.jar then this version is used to resolve the jruby-complete dependency from the local/remote maven repository. defaults to \'1.4.1\'.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
